/*
 * Button.c
 *
 *  Created on: Aug 10, 2012
 *      Author: a0135618
 */


#include <msp430.h>
#include "main.h"
#include "PGA450Comm.h"


#define buttonPort      P2IN
#define BUT_START_MASK  0x08
#define BUTTONS_MASK    0x08
#define BUT_DB_TIME     100


unsigned char butState;
unsigned char butState2;
unsigned char butDbCnt;


void buttonTask(void)
{
    unsigned char state;

    state = buttonPort;
    if((state ^ butState2) & BUTTONS_MASK)
    {
        butState2 &= (~BUTTONS_MASK);
        butState2 |= (state&BUTTONS_MASK);
        butDbCnt = BUT_DB_TIME;
    }

    if(butDbCnt == 0)
    {
        state = (butState ^ butState2) & BUTTONS_MASK;
        if(state)
        {
            if(state & BUT_START_MASK)
            {
                if((butState2 & BUT_START_MASK) == 0)
                {
                    if(pga450Stg == PGA450_STG_IDLE)
                        pga450Stg = PGA450_STG_INIT;
                }
            }

            butState ^= state;
        }
    }
    else
        butDbCnt--;
}

