/*
 * PGA450Comm.h
 *
 *  Created on: Aug 10, 2012
 *      Author: a0135618
 */

#ifndef PGA450COMM_H_
#define PGA450COMM_H_


#define PGA450_TEST_REG_READ_CMD        0x15
#define PGA450_TEST_REG_WRITE_CMD       0x16
#define PGA450_OTP_READ_CMD             0x04
#define PGA450_OTP_WRITE_CMD            0x07
#define PGA450_DEVRAM_READ_CMD          0x1C
#define PGA450_DEVRAM_WRITE_CMD         0x1F
#define PGA450_EEPROM_CACHE_READ_CMD    0x0D
#define PGA450_EEPROM_CACHE_WRITE_CMD   0x0E
#define PGA450_ESFR_READ_CMD            0x19
#define PGA450_ESFR_WRITE_CMD           0x1A


#define PGA450_OK                       0x02
#define PGA450_SPI_FAIL                 0x80
#define PGA450_PARITY_ERR               0x40
#define PGA450_ILLEGAL_ADDR             0x20
#define PGA450_ILLEGAL_CMD              0x10
#define PGA450_WRONG_CLK_CNT            0x08


#define PGA450_REV_ID_REG_ADDR          0x20
#define PGA450_MICRO_RESET_REG_ADDR     0x2F
#define PGA450_MICRO_RESET_CMD          0x01

#define PGA450_EE_CTRL_REG_ADDR         0xC0
#define PGA450_EE_WRTIE_BIT             0x01
#define PGA450_EE_STATUS_BIT            0x01
#define PGA450_EE_RELOAD_BIT            0x02


#define PGA450_FW_SZ                    0x2000
#define PGA450_OTP_ADDR_START           0x0000
#define PGA450_OTP_ADDR_END             0x1FFF


#define PGA450_EE_SZ                    0x0020
#define PGA450_EE_ADDR_START            0x0000
#define PGA450_EE_ADDR_END              0x001F


enum
{
    PGA450_STG_IDLE,
    PGA450_STG_INIT,
    PGA450_STG_VPWR_ON_DLY,
    PGA450_STG_VOTP_ON_DLY,
    PGA450_STG_RESET,
    PGA450_STG_BLANK_CHK,
    PGA450_STG_PROG_OTP,
    PGA450_STG_VERIFY_OTP_EE,
    PGA450_STG_PROG_EE,
    PGA450_STG_VOTP_OFF,
    PGA450_STG_VOTP_OFF_DLY,
    PGA450_STG_MAX
};


extern unsigned char pga450Stg;


extern void pga450Enable(unsigned char id);
extern void pga450Disable(unsigned char id);
extern void pga450LedErr(unsigned char id);
extern void pga450LedOK(unsigned char id);
extern void pga450LedBusy(unsigned char id);
extern void pga450LedIdle(unsigned char id);
extern unsigned char pga450Write(unsigned char id, unsigned char length);
extern unsigned char pga450Read(unsigned char id, unsigned char length);
extern unsigned char pga450Reset(unsigned char id);
extern unsigned char pga450OTP_BlankChk(unsigned char id);
extern unsigned char pga450OTP_Program(unsigned char id);
extern unsigned char pga450OTP_Verify(unsigned char id);
extern void pga450Init(void);
extern void pga450ProgTask(void);


#endif /* PGA450COMM_H_ */
